<?php
/*
	Plugin Name: Bauernregeln
	Plugin URI: http://rvincent.digital-nerv.net/wordpress-plugins/
	Description: Shows a german weather proverb or country saying, called 'Bauernregel', for every month.
	Version: 0.1.4
	Author: Rally Vincent
	Author URI: http://rvincent.digital-nerv.net/
	License: GPL2
*/

/*  Copyright 2009 - 2012 Rally Vincent (email : wordpress@digital-nerv.net)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License, version 2, as 
	published by the Free Software Foundation.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

load_plugin_textdomain( 'bauernregeln', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
 
$bauernregeln_db_version = "0.1.4";

function bauernregeln_update_db_check() {
	global $bauernregeln_db_version;
	if ( get_site_option( 'bauernregeln_db_version' ) != $bauernregeln_db_version ) {
		bauernregeln_uninstall();
		bauernregeln_install();
	}
}
add_action( 'plugins_loaded', 'bauernregeln_update_db_check' );

function bauernregeln_install() {
	global $wpdb;
	global $bauernregeln_db_version;
	$table_name = $wpdb->prefix . 'bauernregeln';
	if($wpdb->get_var( "SHOW TABLES LIKE `$table_name`") != $table_name ) {
		$sql = "CREATE TABLE `$table_name` (`id` int(10) NOT NULL auto_increment, `month` int(10) NOT NULL, `text` text NOT NULL, UNIQUE KEY `id` (`id`))";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 1, 'Im Januar Reif und arger Schnee tut Bäumchen und den Früchten weh.'), 
				(NULL, 1, 'Januarsonne hat weder Kraft noch Wonne.'), 
				(NULL, 1, 'Ist der Januar gelinde, folgen im Lenz die rauen Winde.'), 
				(NULL, 1, 'Werden die Tage länger wird der Winter strenger.'), 
				(NULL, 1, 'Anfang und Ende Januar zeigt uns das Wetter fürs ganze Jahr.'), 
				(NULL, 1, 'Reichlich Schnee im Januar, Dung genug fürs ganze Jahr.'), 
				(NULL, 1, 'Tanzen im Januar die Mucken – Bauer, musst nach Futter gucken!'), 
				(NULL, 1, 'Wenn die Tage langen, kommt die große Käte gegangen.'), 
				(NULL, 1, 'Ist der Jänner rau und hart, ist’s für das Jahr ein guter Start.'), 
				(NULL, 1, 'Januar Schnee zuhauf: Bauer halt den Sack auf!'), 
				(NULL, 1, 'Je näher die Hasen dem Dorfe rücken, desto ärger sind des Eismondes Tücken.'), 
				(NULL, 1, 'Wenn’s nicht mehr richtig wintern tut, wird selten auch der Sommer gut.'), 
				(NULL, 1, 'Januar muss krachen, soll der Frühling lachen.'), 
				(NULL, 1, 'Gelinder Januar bringt spätes Frühjahr.'), 
				(NULL, 1, 'Auf trockenen, kalten Januar folgt meist viel Schnee im Februar.'), 
				(NULL, 1, 'Januar weiß, der Sommer heiß. – Januar warm, dass Gott erbarm!')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 2, 'Wenn der Februar wie ein Wolf heranschleicht, geht er wie ein Lamm. Kommt er wie ein Lamm, geht er wie ein Wolf.'), 
				(NULL, 2, 'Viel Regen im Februar, viel Regen im ganzen Jahr.'), 
				(NULL, 2, 'Lässt der Februar Wasser fallen, lässt es der März gefrieren.'), 
				(NULL, 2, 'Ist der Februar sehr warm, friert man zu Ostern bis in den Darm.'), 
				(NULL, 2, 'Besser im Hornung zu frieren, als draußen im Sonnenschein zu spazieren.'), 
				(NULL, 2, 'Der Hornung hat so seine Mucken, er baut mit Eis oft feste Brucken.'), 
				(NULL, 2, 'Nasser Februar – nass das ganze Jahr.'), 
				(NULL, 2, 'Im Hornung recht viel Schnee und Eis macht den Sommer lange heiß.'), 
				(NULL, 2, 'Der Hornung ist ein eigner Kauz, wenn’s nicht gefroren ist, so taut’s.'), 
				(NULL, 2, 'Früher Vogelgesang macht den Winter lang.'), 
				(NULL, 2, 'Viel Nebel im Februar, bringt Regen oft im Jahr.'), 
				(NULL, 2, 'Wenn’s im Hornung nicht recht wintert, so kommt die Kälte um Ostern.'), 
				(NULL, 2, 'Sonnt sich die Katze im Feber, friert sie sicher im März.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 3, 'Der März soll kommen wie ein Wolf, aber gehen wie ein Lamm.'), 
				(NULL, 3, 'Bleibt die Lerche stumm und steigt nicht hoch, folgt ein nasses Frühjahr noch.'), 
				(NULL, 3, 'Viel Nebel im März, viel Gewitter im Sommer.'), 
				(NULL, 3, 'Zu Anfang und zu End’ der März sein Gift versend’t.'), 
				(NULL, 3, 'Ein feuchter März ist der Bauern Schmerz.'), 
				(NULL, 3, 'In dem Märzen geh – sag manchem Ast ade.'), 
				(NULL, 3, 'Auf Märzenregen folgt kein Sommersegen.'), 
				(NULL, 3, 'Märzenschnee tut \(den\) Saaten weh.'), 
				(NULL, 3, 'Taut’s im März nach Sommerart, kriegt der April einen weißen Bart.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 4, 'Ein Wind, der von Ostern bis Pfingsten regiert im ganzen Jahr sich wenig verliert.'), 
				(NULL, 4, 'Bald trüb und rau, bald licht und mild, ist der April des Menschen Ebenbild.'), 
				(NULL, 4, 'Kommen die Bienen nicht heraus, ist’s mit dem schönen Wetter aus.'), 
				(NULL, 4, 'Dürrer April ist nicht des Bauern Will. April-Regen ist dem Bauern gelegen.'), 
				(NULL, 4, 'Ist der April auch noch so gut, er schneit dem Bauern auf den Hut.'), 
				(NULL, 4, 'Bläst April mit beiden Backen, ist genug zu jäten, hacken.'), 
				(NULL, 4, 'Aprilsturm und Regenwucht bescheren Wein und gute Frucht.'), 
				(NULL, 4, 'Wenn der April wie ein Löwe kommt, so geht er wie ein Lamm.'), 
				(NULL, 4, 'Ist der April recht schön und rein, wird der Mai umso wilder sein.'), 
				(NULL, 4, 'Aprilenglut tut selten gut.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 5, 'Erst Mitte Mai ist der Winter vorbei.'), 
				(NULL, 5, 'Fliegt abends lang die Fledermaus, sagt gutes Wetter sie voraus.'), 
				(NULL, 5, 'Fliegen die Schwalben in den Höh’n, kommt ein Wetter, das ist schön.'), 
				(NULL, 5, 'Auf nassen Mai kommt trockner Juni herbei.'), 
				(NULL, 5, 'Nordwind im Mai, schafft Trockenheit herbei.'), 
				(NULL, 5, 'Wenn im Mai die Bienen schwärmen, sollte man vor Freude lärmen.'), 
				(NULL, 5, 'Maienfröste sind unnütze Gäste.'), 
				(NULL, 5, 'Maientau macht grüne Au.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 6, 'Stellt der Juni mild sich ein, wird mild auch der Dezember sein.'), 
				(NULL, 6, 'Wie’s wittert am Medardustag, so bleibt’s sechs Wochen lang danach.'), 
				(NULL, 6, 'Geben die Johanniswürmchen ungewöhnlich viel Licht, so ist schönes Wetter in Sicht.'), 
				(NULL, 6, 'Fliegen die Fledermäuse abends umher, so kommt ein lang Schönwetter her.'), 
				(NULL, 6, 'Juniregen – reicher Segen.'), 
				(NULL, 6, 'Viermal Juniregen bringt zwölffachen Segen.'), 
				(NULL, 6, 'Wenn die Nacht zu langen beginnt, dann die Hitze am meisten zunimmt.'), 
				(NULL, 6, 'Sind am Sommerabend über Wies’ und Fluss Nebel zu schauen, so wird die Luft anhaltend schön Wetter brauen.')";
		$wpdb->query( $sql );
		$sql = 	"INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 7, 'Der Juli voller Sonnenschein wird jedermann willkommen sein.'), 
				(NULL, 7, 'Genauso wie der Juli war, wird nächstes Mal der Januar.'), 
				(NULL, 7, 'Schnappt im Juli das Weidvieh nach Luft, riecht es schon Gewitterduft.'), 
				(NULL, 7, 'Ein Juli ohne Hagel ist so selten wie ein Kopf ohne Nagel.'), 
				(NULL, 7, 'Macht der Juli uns heiß, bringt der Winter viel Eis.'), 
				(NULL, 7, 'Juliregen nimmt Erntesegen.'), 
				(NULL, 7, 'Wenn die Schwalben im Fluge das Wasser berühren, werden wir bald Regen verspüren.'), 
				(NULL, 7, 'Wenn Donner kommt im Julius viel Regen man erwarten muss.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 8, 'Ist der August am Anfang heiß, wird der Winter streng und weiß.'), 
				(NULL, 8, 'Wenn die Mücken spielen, wird schönes Wetter.'), 
				(NULL, 8, 'Du kannst ohne Schirm aufs Felde gehen, wenn Schäfchenwolken am Himmel stehen.'),
				(NULL, 8, 'Wenn die Mücken tanzen und spielen, sie morgiges gut Wetter fühlen.'),
				(NULL, 8, 'Springende Fische bringen Gewitterfrische.'),
				(NULL, 8, 'Ist der August recht hell und heiß, so lacht der Gärtner im vollen Schweiß.'),
				(NULL, 8, 'Wenn abends die Fledermäuse herumfliegen, so folgt ein anhaltend gut Wetter.'),
				(NULL, 8, 'Fängt August mit Hitze an, bleibt sehr lang die Schlittenbahn.'),
				(NULL, 8, 'Ist’s im August recht drückend schwül, dann ist’s im Schatten auch nicht kühl.'),
				(NULL, 8, 'Wie der August, so der künftige Februar.'),
				(NULL, 8, 'Wie im August das Wetter fällt, so ist’s das ganze Jahr bestellt.'),
				(NULL, 8, 'Wie der August heuer war, wird sein der nächste Februar.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 9, 'Wie’s in der ersten Hälfte September soll’s meistens das ganze Jahr über bleiben.'), 
				(NULL, 9, 'Septemberdonner prophezeit reichlich Schnee zur Weihnachtszeit.'), 
				(NULL, 9, 'Auf Schwalb und Eichhorn achte bald, sind sie verschwunden, wird’s schnell kalt.'), 
				(NULL, 9, 'Fällt im Wald das Laub sehr schnell, ist der Winter bald zur Stell.'), 
				(NULL, 9, 'Soll der September den Gärtner erfreun, so muss er gleich dem Märze sein.'), 
				(NULL, 9, 'September schön in den ersten Tagen, will den ganzen Herbst ansagen.'), 
				(NULL, 9, 'So der nächste März, wie der September, so der Juni, wie der Dezember.'), 
				(NULL, 9, 'Donnert’s im September noch, liegt zu Weihnacht der Schnee recht hoch.'), 
				(NULL, 9, 'Kommen im Herbst viel Spinnen ins Haus, webt der Winter mit hartem Graus.'), 
				(NULL, 9, 'Der September ist der Mai des Herbstes.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 10, 'Wenn’s im Oktober friert und schneit, bringt der Jänner milde Zeit.'), 
				(NULL, 10, 'Schneit’s im Oktober gleich, dann wird der Winter weich.'), 
				(NULL, 10, 'Oktoberschnee tut Tieren und Pflanzen weh.'), 
				(NULL, 10, 'Bringt der Oktober viel Frost und Wind, so sind der Januar und Hornung gelind.'), 
				(NULL, 10, 'Oktoberwetter zeigt stets an, wie’s künftig um den März wird stahn.'), 
				(NULL, 10, 'Oktoberwetter warm und hell, bringt kalten Wind und Winter schnell.'), 
				(NULL, 10, 'Fällt im Oktober das Laub sehr schnell, ist der Winter bald zur Stell’.'), 
				(NULL, 10, 'Hat der Oktober viel Regen gebracht, hat er die Gottesäcker bedacht.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 11, 'Hängt das Laub bis zum November hinein, wird der Winter ein langer sein.'), 
				(NULL, 11, 'Für den November gilt althergebracht, dass er die Gottesäcker bedacht.'), 
				(NULL, 11, 'Wie der November, so der folgende Mai.'), 
				(NULL, 11, 'Glatter Pelz beim Wilde, dann wird der Winter milder.'), 
				(NULL, 11, 'November warm und klar, wenig Segen fürs nächste Jahr.'), 
				(NULL, 11, 'Tummeln sich noch die Haselmäuse, ist es noch weit mit des Winters Eise.'), 
				(NULL, 11, 'Friert im November früh das Wasser, dann wird der Jänner um so nasser.'), 
				(NULL, 11, 'Hält die Buche noch lange die Blätter fest, basld große Kält’ erwarten lässt.'), 
				(NULL, 11, 'Bringt der November Morgenrot, sei sicher, dass langer Regen droht.')";
		$wpdb->query( $sql );
		$sql = "INSERT INTO `$table_name` (`id`, `month`, `text`) VALUES 
				(NULL, 12, 'Wintert’s vor Weihnachten nicht, so wintert’s nach.'), 
				(NULL, 12, 'Kalter Dezember – zeitiger Frühling.'), 
				(NULL, 12, 'Dezember kalt mit Schnee, gibt Korn auf jeder Höh’.'), 
				(NULL, 12, 'Dezember lau und lind, der ganze Winter ein Kind.'), 
				(NULL, 12, 'Wenn in der ersten Adventswoche kaltes strenges Wetter herrscht, so soll es 18 volle Wochen anhalten.'), 
				(NULL, 12, 'Dezember veränderlich und lind, der ganze Winter ein Kind.'), 
				(NULL, 12, 'Wenn es vor Weihnachten nicht vorwintert, so wintert es im Frühjahr nach.'), 
				(NULL, 12, 'Trockener Dezember, trockenes Frühjahr und trockener Sommer.'), 
				(NULL, 12, 'So kalt im Dezember, so heiß wird’s im Juni.'), 
				(NULL, 12, 'Donner im Winterquartal bringt uns Eiszapfen ohne Zahl.'), 
				(NULL, 12, 'Gefriert’s zu Sylvester in Berg und Tal, ist’s dieses Jahr das letzte Mal.')";
		$wpdb->query( $sql );
		add_option( 'bauernregeln_db_version', $bauernregeln_db_version );
	}
}
register_activation_hook( __FILE__, 'bauernregeln_install' );

function bauernregeln_uninstall() {
	global $wpdb;
	$table_name = $wpdb->prefix . 'bauernregeln';
	$wpdb->query( "DROP TABLE `$table_name`" );
	delete_option( 'bauernregeln_db_version' );
}
register_deactivation_hook( __FILE__, 'bauernregeln_uninstall' );

class BauernregelnWidget extends WP_Widget {
	function BauernregelnWidget() {
		$widget_ops = array( 
						'classname' => 'BauernregelnWidget', 
						'description' => __("Shows a german weather proverb or country saying, called 'Bauernregel', for every month.", "bauernregeln") 
					);
		$control_ops = array( 'width' => 300, 'height' => 300 );
		$this->WP_Widget( 'Bauernregeln', __("Bauernregeln", "bauernregeln"), $widget_ops, $control_ops );
	}
	function widget( $args, $instance ) {
		global $wpdb;
		extract( $args );
		echo $before_widget;
		$monate = array( 'Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember' );
		$monat = date( 'n' );
		$title = apply_filters( 'widget_title', empty($instance['title']) ? '&nbsp;' : $instance['title'] );
		$title = sprintf( $title, $monate[$monat - 1] );
		if ( $title ) {
			echo $before_title . $title . $after_title;
			$table_name = $wpdb->prefix . 'bauernregeln';
			$sql = "SELECT * FROM `$table_name` WHERE `month` = $monat ORDER BY RAND() LIMIT 0, 1";
			$results = $wpdb->get_results($sql);
			if ( $results ) {
				foreach ($results as $result) {
					printf( '<p>%s</p>', $result->text );
				}
			}
		}
		echo $after_widget;
	}
	function form($instance) {
		$instance = wp_parse_args( (array)$instance, array( 'title' => '' ) );
		$title = strip_tags( $instance['title'] );
		?>
		<p>
		  <label for="<?php echo $this->get_field_id( 'title' ); ?>">
			<?php _e( 'Title', 'bauernregeln' ); ?>:
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo attribute_escape( $title ); ?>" />
		  </label>
		</p>
		<p>
			<?php _e( 'To show the current month (in german language) in the title, add <b>%s</b> anywhere in the title text.', 'bauernregeln' ); ?>
		</p>
		<p>
			<b><?php _e( 'Examples', 'bauernregeln' ); ?>:</b>
			<br /> 
			<i>Spruch des Monats %s</i>
			<br /> 
			<?php _e( 'or', "bauernregeln" ); ?>
			<br /> 
			<i>Das sagt im %s der Bauer</i>
		</p>
		<?php
	}
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags( stripslashes( $new_instance['title'] ) );
		return $instance;
	}
}

function BauernregelnWidgetInit() { 
	register_widget( 'BauernregelnWidget' ); 
}
add_action( 'widgets_init', 'BauernregelnWidgetInit' );
?>